class Task {
  final bool done;
  final DateTime? begin;
  final DateTime? end;
  final String title;
  final List<String> contexts;
  final List<String> projects;
  final Map<String,String> meta;
  final String? priority;

  Task({
    required this.title,
    this.done = false,
    this.contexts = const [],
    this.projects = const [],
    this.meta = const {},
    this.priority,
    this.begin,
    this.end,
  });

  static String formatDate(DateTime dt) {
    return "${dt!.year}-${dt!.month.toString().padLeft(2,'0')}-${dt!.day.toString().padLeft(2,'0')}";
  }

  @override
  String toString() {
    return (done ? "x " : "")
         + (priority == null ? "" : "(${priority!}) ")
         + (begin == null ? "" : "${Task.formatDate(begin!)} ")
         + (end == null ? "" : "${Task.formatDate(end!)} ")
         + ("$title ")
         + meta.entries.map((entry) => "${entry.key}:${entry.value}").join(" ")
    ;
  }
}